//     <Legal>     Copyright (c) 1997-1999 Quicksilver Software, Inc.
//     Permission is granted to use this file solely in accordance with the terms and
//     conditions in the SFC Mission API Software Use Limitations and Limited License.
//     All other rights reserved.
//
//     <Module>     Star Trek: Starfleet Command Mission API

#ifndef scriptentry_h
#define scriptentry_h

//-------------------------------------------------------
// interface specific routines
class tScriptEntry
{
protected:
	typedef void  WINAPI cbCreateShip (tCreateShipInfo& info);
	typedef void  WINAPI cbEntityMgr (tShipSystemsInfo& info);
	typedef void  WINAPI cbMessages (tString& message, eScriptMessageTypes type, int32 ShipID);
	typedef int32 WINAPI cbRandom (int32 lo, int32 hi);

public:
	virtual int32		mDLLVersion (void) = 0;
	virtual void		mInitialize (tDynaverseScriptInfo& info) = 0;
	virtual iTruth		mSaveEntityID (int32 Team, int32 CallbackIndex, int32 EntityID) = 0;
	virtual eGameStatus	mEntityEvent (tShipSystemsInfo& info) = 0;
	virtual void		mInitMapForRead (void) = 0;
	virtual const char* mGetNextMapLine (void) = 0;
	virtual tString&	mBriefingText (void) = 0;
	virtual	int32		mGetDebriefingTotal (void) = 0;
	virtual tString&	mDebriefingText (int32 Index) = 0;
	virtual int32		mGetPrestigePoints (eVictoryLevels Level) = 0;
	virtual iTruth		mGetScriptSpecs (tMissionSpec* Specs) = 0;
	virtual int32		mGetTechnicalSuccess (tDynaverseScriptInfo& info) = 0;
	virtual eTeamRelationship mGetTeamRelations (eTeamID Team1, eTeamID Team2) = 0;

	virtual void		mEntityMgrCallback (cbEntityMgr* func) = 0;
	virtual void		mCreateShipCallback (cbCreateShip* func) = 0;
	virtual void		mMessageCallback (cbMessages* func) = 0;
	virtual void		mRandomCallback (cbRandom* func) = 0;
};

#endif		// #ifndef scriptentry_h

