//	<Name>	eshiptypes.h

//     <Legal>     Copyright (c) 1997-1999 Quicksilver Software, Inc.
//     Permission is granted to use this file solely in accordance with the terms and
//     conditions in the SFC Mission API Software Use Limitations and Limited License.
//     All other rights reserved.
//
//     <Module>     Star Trek: Starfleet Command Mission API

//	<Info>	enums for ship types
#ifndef eshiptypes_h
#define eshiptypes_h

	// Ships
// if you change the enum -- make sure to update entity_strings.cpp and tactical.txt(in QSIsourceassets)
// And of course shadowdata.cpp, which is a cool new redundant feature I just found!
	enum eHullType {
		kUndefinedHull	= -1,
		kUndefinedShip	= -1,
		kNoHullType = -1,
		kCA,
		kCL,
		kDN,
		kF,
		kFF,
		kDD,
		kSB,
		kBS,
		kBT,
		kHullListeningPost,
		kHullDefensePlatform,
		kHullStarDock,
		kHullAstroMiner,			// start of monster hulls
		kHullSunGlider,
		kHullDoomsdayMachine,
		kHullLivingCage,
		kHullM_Eater,
		kHullSpaceShell,
		kMineHull,
		kFighter,
		kNumberOfShipHullTypes,

				//  The following are used to index into the list of hull schematic names
				//  in schematicpanel.cpp
		kHullPlanet1 = kNumberOfShipHullTypes,
		kHullPlanet2,
		kHullPlanet3,
		kHullPlanet4,
		kHullPlanet5,
		kHullPlanet6,
		kHullPlanet7,
		kHullPlanet8,
		kHullPlanet9,
		kHullPlanet0,
		kHullStar,
		kHullAsteroid,
		kHullPlasmaTorpedo,
		kHullDrones,
		kHullBodies,
		kHullFissure,
		kHullWormHole,
		kHullFedShuttle,
		kHullKlingShuttle,
		kHullRomShuttle,
		kHullLyranShuttle,
		kHullHydranShuttle,
		kHullGornShuttle,
		kUnknownHull,
		kNumTotalHulls,
		_eHullTypePadToLong = 0xFFFFFFFF
	};

	extern const char *gHullTypes[kNumTotalHulls];


	// if you change the enum -- make sure to update entitystrings.cpp
	enum eTurnMode{
		kNoTurnMode = -1,
		kTurnModeAA = 0,
		kTurnModeA,
		kTurnModeB,
		kTurnModeC,
		kTurnModeD,
		kTurnModeE,
		kTurnModeF,
		kTurnModeG, // Planets
		kNumberOfTurnModes
	};

	extern const char *gTurnModes[kNumberOfTurnModes];

	// if you change the enum -- make sure to update entitystrings.cpp
	enum eSpecialRole
	{
		kNoSpecialRole = -1,
		kSpecialRoleC,
		kSpecialRoleD,
		kSpecialRoleK,
		kSpecialRoleKM,
		kSpecialRoleM,
		kSpecialRoleS,
		kNumberOfSpecialRoles
	};

	extern const char *gSpecialRoles[kNumberOfSpecialRoles];

#endif
