//	<Name>	missionspec.h

//     <Legal>     Copyright (c) 1997-1999 Quicksilver Software, Inc.
//     Permission is granted to use this file solely in accordance with the terms and
//     conditions in the SFC Mission API Software Use Limitations and Limited License.
//     All other rights reserved.
//
//     <Module>     Star Trek: Starfleet Command Mission API

#ifndef missionspec_h
#define missionspec_h

#include "tstring.h"

#define tMissionSpecVersion  6.0f

			//  Bit masks for number of ships
#define MissSpecOneShip			1
#define MissSpecTwoShip			2
#define MissSpecThreeShip		4
#define MissSpecAllShips		(MissSpecOneShip | MissSpecTwoShip | MissSpecThreeShip)

			// Bit masks for sector classification
enum eMissSpecSect { kPlayerCapital =   1,	kPlayerColonial   =   2,	kEnemyBorder     =   4,
					 kAlliedBorder  =   8,	kOccupiedColonial =  16,	kOccupiedCapital =  32,
					 kWarzone       =  64,	kEnemyCapital     = 128,	kEnemyColonial   = 256,
					 kUnexplored    = 512,	kAllSectors		  = 767 };

			// Bit masks for race (assumed to be in same order as eRaceName
enum eMissSpecRace { kFedMission    =   1,	kKlingMission     =   2,	kRomulanMission  =   4,
					 kLyranMission  =   8,	kHydranMission    =  16,	kGornMission     =  32,
					 kOrionMission  =  64,	kNonPirateMission =  63,	kAllRaceMission  = 127,
					 kEliteRaceMission = 128
					};

enum eMissionTypes { kCampaignMission, kTutorialMission, kTechnicalMission, kHistoricalMission, kMultiplayerMission };

struct tMissionSpec
{
	public:
		float		fVersion;
		tString		fFileName;
		const char*	fMissionTitle;
		tString		fPersistentMissionTitle;
		eMissionTypes	fMissionType;	// Set with one of the eMissionType values
		int32		fSectorType;	// Logical OR the MissSpecSect values
		int32		fPlayerRace;	// Logical OR the MissSpecRace values
		int32		fEnemyRace;		// Logical OR the MissSpecRace values
		int32		fNumShips;		// Logical OR the number of ship values
		int32		fMinBPV;
		int32		fMaxBPV;
		int32		fMinDate;
		int32		fMaxDate;
		int32		fWait;			// also indicates menu position for Tutorial and Technical missions
		int32		fEnableSupplyDock;		// uses eMenuButtons values
};

#endif	// #ifndef missionspec_h
