//	<Name>	tcglue.h

//     <Legal>     Copyright (c) 1997-1999 Quicksilver Software, Inc.
//     Permission is granted to use this file solely in accordance with the terms and
//     conditions in the SFC Mission API Software Use Limitations and Limited License.
//     All other rights reserved.
//
//     <Module>     Star Trek: Starfleet Command Mission API

#pragma once

#ifndef	tcglue_h
#define	tcglue_h	1

#include "tlearn.h"
#include "tbasic.h"


// qualifications for being included in the clib glue:
// 1. stateless (no side effects)
// 2. available or implementable on all targets
// 3. expressible in terms of basic types (*without reference to the C runtime headers*)

class	clib
{
	public:

		typedef unsigned size_t;

		static	void	memset( void *destPtr, int8u value, iCount count );
		static  void	*memcpy( void *dest, const void *src, size_t count );
		static  int		memcmp( void *dest, const void *src, size_t count );
		static	void	strcpy( char *dest, const char *source);
		static	iCount	strlen( const char *string );

};

#endif
