//	<Name>	tigerstl.h

//     <Legal>     Copyright (c) 1997-1999 Quicksilver Software, Inc.
//     Permission is granted to use this file solely in accordance with the terms and
//     conditions in the SFC Mission API Software Use Limitations and Limited License.
//     All other rights reserved.
//
//     <Module>     Star Trek: Starfleet Command Mission API

#pragma once

#ifndef	tigerstl_h
#define	tigerstl_h	1

#include "tlearn.h"


// shorthands
// T is a type
// CT is a container of a type
// OrdT is an ordering of a type, like less<int>

	// seq'd containers
#define	xvector(T)					vector	<T>
#define	xlist(T)					list	<T>
#define	xdeque(T)					deque	<T>

	// assoc containers
#define	xset(T,CT)					set< T, CT >
#define	xmultiset(T,CT)				multiset< T, CT >

#define	xmap(keyT,outT,OrdT)		map< keyT, outT, OrdT >
#define	xmultimap(keyT,outT,OrdT)	multimap< keyT, outT, OrdT >


	// adaptors
#define	xqueue(CT,T)				queue			< T, CT<T> >
#define	xpriority_queue(CT,T,OrdT)	priority_queue	< T, CT<T>, OrdT >
#define	xstack(CT,T)				stack			< T, CT<T> >

#include <vector>
#include <deque>
#include <list>

	// assoc containers
#include	<set>
#include	<map>

	// adaptors
#include <stack>
#include <queue>

	// algorithm stuff
#include <algorithm>

using namespace std;

// STL that comes with VC5 doesn't conflict with min/max unlike TG_STL
#undef NOMINMAX
#include <minmax.h>

	
//
//	Simplification macros (using deque<> and less<>)
//

#define		sxset(T)				xset( T , less< T > )
#define		sxmultiset(T)			xmultiset( T , less< T > )
#define		sxmap(keyT,outT)		xmap( keyT , outT , less< keyT > )
#define		sxmultimap(keyT,outT)	xmultimap( keyT , outT , less< keyT > )
#define		sxqueue(T)				xqueue( deque , T )
#define		sxpriority_queue(T)		xpriority_queue( deque , T , less< T > )
#define		sxstack(T)				xstack( deque , T )


#endif	// endif on tigerstl_h
