//	<Name>	tlearn.h

//     <Legal>     Copyright (c) 1997-1999 Quicksilver Software, Inc.
//     Permission is granted to use this file solely in accordance with the terms and
//     conditions in the SFC Mission API Software Use Limitations and Limited License.
//     All other rights reserved.
//
//     <Module>     Star Trek: Starfleet Command Mission API


#ifndef	tlearn_h
#define	tlearn_h	1

#ifndef	__cplusplus
	#error C++ compiler must be activated.
#endif


	//	define all the symbols to 0 first
	// these are intended to be used with #if (not #ifdef!)
	// thus any of them can be  used by value in any circumstance.

	//	compiler symbols
#define	CompilerBorland			0
#define	CompilerMetrowerks		0
#define	CompilerOldMetrowerks	0
#define	CompilerMicrosoft		0
#define	CompilerWatcom			0

	//	chip symbols
#define	Chip68K				0
#define	ChipPPC				0
#define ChipX86				0

	//	environment symbols
#define	SystemMac7			0
#define	SystemWin32			0

#define	EndianBig			0
#define	EndianLittle		0



	//	Compiler and chip sensing


#ifdef	_MSC_VER					// Microsoft sensing
	#undef	CompilerMicrosoft
	#define	CompilerMicrosoft		1

												// Turn off unknown pragma warnings for
												// #pragma once when in MSVC++
	#pragma warning( disable: 4068 4786 4114 4236)
												// Also turn off warnings for "Identifier was truncated to '255' characters in the browser information"
												// and "same type qualifier used more than once"
												// and "'__export' is an obsolete keywork"
	#if	(_M_IX86 >= 300)

		#undef	ChipX86
		#define	ChipX86				1
		
		#ifdef	_WIN32
			#undef	SystemWin32
			#define	SystemWin32		1
		#else
			#error	Microsoft: not Win32.
		#endif

	#else

		#error	Microsoft: not >= 386.

	#endif
#endif


	// Ensure compiler was detected.

#if	CompilerMicrosoft
#else
	#error	Compiler not recognized.
#endif


	// Ensure chip was detected, set endian flags at the same time.

#if	ChipX86

	#undef	EndianLittle
	#define	EndianLittle	1
	
#else
	#error	Chip not recognized.
#endif



	// Ensure OS was detected, set endian flags at the same time.

#if	SystemWin32
#else
	#error	Target OS not recognized.
#endif

#ifdef	UNICODE
	#error	UNICODE is not supposed to be defined.
#endif

#endif	// end tlearn_h block for file

